unit Unit1;

{$WARN SYMBOL_PLATFORM OFF}

interface

uses
  ComObj, ActiveX, Project2_TLB, StdVcl, AddInDesignerObjects_TLB, OleServer,
  Classes, SysUtils, Graphics, Clipbrd, StdCtrls, Variants;
type

TCommandBarButtonClick = procedure(const Ctrl: OleVariant; var CancelDefault: OleVariant) of Object;
TCommandBarButton = class(TOleServer)
private
 FIntf: CommandBarButton;
 FOnClick: TCommandBarButtonClick;
 function GetDefaultInterface: CommandBarButton;
 procedure SetOnClick(const Value: TCommandBarButtonClick);
protected
 procedure InitServerData; override;
 procedure InvokeEvent(DispID: TDispID; var Params: TVariantArray); override;
public
 constructor Create(AOwner: TComponent); override;
 destructor  Destroy; override;
 procedure Connect; override;
 procedure ConnectTo(svrIntf: CommandBarButton);
 procedure Disconnect; override;
 property DefaultInterface: CommandBarButton read GetDefaultInterface;

published
 property OnClick : TCommandBarButtonClick read FOnClick write SetOnClick;
end;

  TTest = class(TAutoObject, _IDTExtensibility2)
  protected
    procedure OnAddInsUpdate(var custom: PSafeArray); safecall;
    procedure OnBeginShutdown(var custom: PSafeArray); safecall;
    procedure OnConnection(const Application: IDispatch;
      ConnectMode: ext_ConnectMode; const AddInInst: IDispatch;
      var custom: PSafeArray); safecall;
    procedure OnDisconnection(RemoveMode: ext_DisconnectMode;
      var custom: PSafeArray); safecall;
    procedure OnStartupComplete(var custom: PSafeArray); safecall;
  private
   FCommandBarButton : TCommandBarButton;
   procedure FClick(const Ctrl: OleVariant; var CancelDefault: OleVariant);
  end;



implementation

uses ComServ;

procedure TTest.OnAddInsUpdate(var custom: PSafeArray);
begin

end;

procedure TTest.FClick(const Ctrl: OleVariant;
var CancelDefault: OleVariant);
begin
Ctrl.Application.Selection.TypeText(DateTimeToStr(Now) + #13#10);
end;

procedure TTest.OnBeginShutdown(var custom: PSafeArray);
begin

end;
{
procedure TTest.OnConnection(const Application: IDispatch;
  ConnectMode: ext_ConnectMode; const AddInInst: IDispatch;
  var custom: PSafeArray);
begin

end;}
procedure TTest.OnConnection(const Application: IDispatch;
ConnectMode: ext_ConnectMode; const AddInInst: IDispatch;
var custom: PSafeArray);
//oOq귽Ū@Bitmapýƻs߶KO
procedure CopyBitMapToClipBoard;
var
 aStream : TStream;
 aBitMap : Graphics.TBitmap;
begin
 with TClipboard.Create do
 begin
   try
     aStream := TResourceStream.CreateFromID(HInstance, 1, RT_RCDATA);
     aBitMap := Graphics.TBitmap.Create;
     aBitMap.LoadFromStream(aStream);
     Assign(aBitMap);
   finally
     aStream.Free;
     aBitMap.Free;
     Free;
   end;
 end;
end;
var
App : WordApplication;
aCommandBar : CommandBar;
aButton : _CommandBarButton;
begin
App := WordApplication(Application);
aCommandBar := App.CommandBars.Add('Test', msoBarTop, False, True);
aButton := aCommandBar.Controls.Add(msoControlButton, EmptyParam, EmptyParam, EmptyParam, True) as _CommandBarButton;
aButton.Set_Style(msoButtonIconAndCaption);
aButton.Set_Caption('Test');
//CopyBitMapToClipBoard; //oyܬOs]w@ӥ~ϼСA
//aButton.PasteFace; //AnW[@rcdatabitmap귽bitmapjp16*16,򰵽аѦҨL
aButton.Set_Tag('test111');
FCommandBarButton := TCommandBarButton.Create(nil);
FCommandBarButton.ConnectTo(aButton);
FCommandBarButton.OnClick := FClick;
aCommandBar.Set_Visible(True);
end;

procedure TTest.OnDisconnection(RemoveMode: ext_DisconnectMode;
  var custom: PSafeArray);
begin
FCommandBarButton.Disconnect;
FCommandBarButton.Free;

end;

procedure TTest.OnStartupComplete(var custom: PSafeArray);
begin

end;

{ TCommandBarButton }

procedure TCommandBarButton.Connect;
var
punk: IUnknown;
begin
if FIntf = nil then
begin
 punk := GetServer;
 ConnectEvents(punk);
 Fintf:= punk as CommandBarButton;
end;
end;

procedure TCommandBarButton.ConnectTo(svrIntf: CommandBarButton);
begin
Disconnect;
FIntf := svrIntf;
ConnectEvents(FIntf);
end;

constructor TCommandBarButton.Create(AOwner: TComponent);
begin
inherited;

end;

destructor TCommandBarButton.Destroy;
begin

inherited;
end;

procedure TCommandBarButton.Disconnect;
begin
if Fintf <> nil then
begin
 DisconnectEvents(FIntf);
 FIntf := nil;
end;
end;

function TCommandBarButton.GetDefaultInterface: CommandBarButton;
begin
if FIntf = nil then
 Connect;
Assert(FIntf <> nil, 'DefaultInterface is NULL. Component is not connected to Server. You must call ''Connect'' or ''ConnectTo'' before this operation');
Result := FIntf;
end;

procedure TCommandBarButton.InitServerData;
const
CServerData: TServerData = (
 ClassID:   '{55F88891-7708-11D1-ACEB-006008961DA5}';
 IntfIID:   '{000C030E-0000-0000-C000-000000000046}';
 EventIID:  '{000C0351-0000-0000-C000-000000000046}';
 LicenseKey: nil;
 Version: 500);
begin
ServerData := @CServerData;
end;

procedure TCommandBarButton.InvokeEvent(DispID: TDispID;
var Params: TVariantArray);
begin
case DispID of
 -1: Exit;  // DISPID_UNKNOWN
1: if Assigned(FOnClick) then
   FOnClick(Params[0], Params[1]);
end; {case DispID}
end;

procedure TCommandBarButton.SetOnClick(
const Value: TCommandBarButtonClick);
begin
FOnClick := Value;
end;


initialization
  TAutoObjectFactory.Create(ComServer, TTest, Class_Test,
    ciMultiInstance, tmApartment);
end.
